/*********************************************************************
	
	=== Gradation Color Generator ===
	
	* Gradation [ Gradation.js ]
	
	* updated 2001/05/28
	
	mail : peace@skipup.com
	home : http://www.skipup.com/~peace/
	
*********************************************************************/



// public class Gradation extends Object
function Gradation(){
	
	var G = Gradation ;
	
	var P = Point3 ;
	
	/***************************** SET_STATIC_MEMBER - BEGIN *****************************/
	
	// public static string
	// if( length == 3 ) : (string)text , (color)c0 ,             (color)c2
	// if( length == 4 ) : (string)text , (color)c0 , (color)c1 , (color)c2
	// if( length == 5 ) : (string)text , (color)c0 ,             (color)c2 , (int)xLoop , (int)yLoop
	// if( length == 6 ) : (string)text , (color)c0 , (color)c1 , (color)c2 , (int)xLoop , (int)yLoop
	G.getText = G.getHTML = function(){
		var a      = arguments ;
		var k      = a.length ;
		var loop   = ( k == 5 || k == 6 );
		var text   = a[0];
		var c0     = a[1];
		var c1     = ( k == 4 || k == 6 ) ? a[2] : "" ;
		var c2     = loop ? a[ k-3 ] : a[ k-1 ] ;
		var xLoop  = loop ? a[ k-2 ] : 1 ;
		var yLoop  = loop ? a[ k-1 ] : 1 ;
		var colors = G.getColor( c0 , c1 , c2 , text.length*xLoop );
		var result = ( document.layers !== void 0 ) ? "<span style=\"color:#000000;\"><\/span>" : "" ;
		var tempt  = text ;
		for(var i=0;i<xLoop-1;i++) text += tempt ;
		for(var i=0;i<text.length;i++) result += "<span style=\"color:#"+colors[i]+"\">"+text.charAt(i)+"<\/span>" ;
		var tempr  = "<br>"+result ;
		for(var i=0;i<yLoop-1;i++) result += tempr ;
		return result ;
	};
	
	// public static string[]
	// if( length == 3 ) : (color)c0 ,             (color)c2 , (int)n
	// if( length == 4 ) : (color)c0 , (color)c1 , (color)c2 , (int)n
	G.getColor = function(){
		var a  = arguments ;
		var k  = a.length ;
		var c0 = a[0];
		var c1 = ( k == 4 ) ? a[1] : "" ;
		var c2 = a[ k-2 ];
		var n  = a[ k-1 ];
		var r  = new Array( n );
		var cs = G.getObject( c0 , c1 , c2 , n );
		for(var i=0;i<n;i++) r[i] = cs[i].toColor();
		return r ;
	};
	
	// public static Point3[]
	// if( length == 3 ) : (color)c0 ,             (color)c2 , (int)n
	// if( length == 4 ) : (color)c0 , (color)c1 , (color)c2 , (int)n
	G.getObject = function(){
		var a  = arguments ;
		var k  = a.length ;
		var c0 = a[0];
		var c2 = a[ k-2 ];
		var n  = a[ k-1 ];
		switch( k ){
			case 3 : default : {
				var r = new Array( n-- );
				var s = new P( c0 );
				var d = new P( s );
				d.scale( n-1 );
				d.add( new P( c2 ) );
				d.scale( 1/n );
				d.sub( s );
				for(var i=0;i<r.length;i++){
					r[i] = new P( s );
					s.add( d );
				}
				return r ;
			}
			case 4 : {
				var c1 = a[1];
				if( c1 == "" ){
					return G.getObject( c0 , c2 , n );
				}else{
					var m = Math.floor( n/2 );
					var s = n&1 ;
					var r0 , r1 ;
					var p = new Array( new P(c0) , new P(c1) , new P(c2) );
					if( s == 0 && ( p[0].distance( p[1] ) < p[1].distance( p[2] ) ) ){
						r0 = G.getObject( c0 , c1 , m   );
						r1 = G.getObject( c1 , c2 , m+1 );
					}else{
						r0 = G.getObject( c0 , c1 , m+1 );
						r1 = G.getObject( c1 , c2 , m+s );
					}
					return ( r0.concat( r1.slice( 1 , r1.length ) ) );
				}
			}
		}
	};
	
	// public static string
	G.toString = function(){ return "Gradation" ; };
	
	/***************************** SET_STATIC_MEMBER - E N D *****************************/
	
} new Gradation();

